/* This file belongs to tranalyzer2 and was taken from tranalyzer
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

#ifndef SUBNET_H_
#define SUBNET_H_

#include <sys/types.h>
#include <inttypes.h>

#define NETWORKLABELING	1	// 0: Address Count, 1: User Labeling
#define NETWORK_HEXLABEL 1	// 0: interger, 1: hex

typedef struct subnet {
	uint32_t net; // in Network Order ! 
	uint32_t mask;
#if NETWORKLABELING == 1
	uint32_t memberNet;
#endif
} subnet_t;

typedef struct subnettable {
	uint32_t count; // subnet count can be higher than 65535 ;-)
	subnet_t* subnets;
} subnettable_t;

uint32_t subnet_test(subnettable_t* table, in_addr_t ip);
void subnet_init(subnettable_t* table, char* bw_file);
int subnet_load(char* bw_file, subnet_t* subnets);

int subnet_i;

#endif /* SUBNET_H_ */
