/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef __BASICLAYER4CALCSTATISTICS_H__
#define __BASICLAYER4CALCSTATISTICS_H__

#define BASIC_PKT_STATS 1

// includes
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// local includes
#include "main.h"
// structs

// everything that is calculated per flow. 20 Bytes allocated
typedef struct basicStatsPerFlow_s {
	uint64_t numTransPackets; // Number of packets transmitted.
        uint64_t numTransBytes; // Number of bytes transmitted 
#if BASIC_PKT_STATS != 0
        uint16_t minL3PacketSize; // Smallest L3 packet size detected
        uint16_t maxL3PacketSize; // Largest L3 packet size detected
#endif // BASIC_PKT_STATS
} basicStatsPerFlow_t;

// variables
basicStatsPerFlow_t *basicStatsPerFlow;
extern FILE *flowStatsFile;
unsigned long pluginBasicLayer4CalcStatisticsIndex;
// global variables
#ifdef __APPLE__
extern hashMap_t *mainHashMap;
extern outputBuffer_t *main_output_buffer;
extern flow_t *flows;
#endif // __APPLE__
// functions
char* get_plugin_name();
char* get_plugin_version();
unsigned int get_supported_tranalyzer_version_major();
unsigned int get_supported_tranalyzer_version_minor();
void initialize(unsigned long pPluginIndex);
binary_value_t *printHeader();
void claimLayer4Information(packet_t *packet, unsigned long flowIndex);
void onFlowTerminate(unsigned long flowIndex);
void onFlowGenerated(packet_t *packet, unsigned long flowIndex);
void onApplicationTerminate();

#endif

