/*
 * macRecorder.h
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef TRANALYZER_PLUGIN_SKELETON_H_
#define TRANALYZER_PLUGIN_SKELETON_H_

#include "main.h"
#include "tranalyzer.h"
#include "networkHeaders.h"
#include "binaryValue.h"
#include "getter.h"

typedef struct macList_s {
	ethernetHeader_t ethernetHeader;
	uint64_t numOfPackets;
	struct macList_s *next;
} macList_t;

typedef struct macRecorder_s {
	uint32_t num_of_entries;
	macList_t *macList;
} macRecorder_t;

// variables
macList_t *macRecorder_macList; // the big struct with all list entrys
macList_t *macRecorder_freeList; // pointer to the first free entry
macRecorder_t *macRecorder_macArray; // the big struct for all flows
unsigned long pluginMacRecorderIndex;
#ifdef __APPLE__
// global variables
hashMap_t *mainHashMap;
outputBuffer_t *main_output_buffer;
#endif // __APPLE__ 
char* get_plugin_name();
char* get_plugin_version();
unsigned int get_supported_tranalyzer_version_major();
unsigned int get_supported_tranalyzer_version_minor();
void initialize(unsigned long pPluginIndex);
binary_value_t* printHeader();
void onFlowGenerated(packet_t *packet, unsigned long flowIndex);
void claimLayer4Information(packet_t *packet, unsigned long flowIndex);
void onFlowTerminate(unsigned long flowIndex);
void onApplicationTerminate();

#endif /* TRANALYZER_PLUGIN_SKELETON_H_ */
