/*      openDPIwrapper.h
*       Torben Rühl,	Mischa Lehmann
*       		ducksource@duckpond.ch
*
*       Version:2.0
*
*       openDPI-wrapper header file
*       Require:
*		- stdio.h
*		- stdlib.h
*		- opendpi
*		- tranalyzer-header files
*
*
*       Licence:
*       You're allowed to edit and publish my source in all of your free and open-source projects.
*       Please send me an e-mail if you'll implement this source in one of your commercial or proprietary projects.
*       Leave this Header untouched!
*
*       Warranty:
*       Warranty void if signet is broken
*       =================== / /===================
*       [       Warranty   / /   Signet          ]
*       ==================/ /=====================
*	!!NOWAY!!
*
*/

/*==============================*/
/*             TODO's           */
/*==============================*/
/*
*
*
*
*
*
*
*/

/*==============================*/
/*           includes           */
/*==============================*/
#ifndef OPENDPIWRAPPER_H_
	#define OPENDPIWRAPPER_H_ 

	/*all Libraries*/
	#include <stdio.h>
	#include <string.h>

#ifndef OPENDPI_DEBUG
	#define OPENDPI_DEBUG 0 
#endif

#if OPENDPI_DEBUG > 0 
	#define IPOQUE_ENABLE_DEBUG_MESSAGES OPENDPI_DEBUG
#endif


	#include "opendpi-1.3.0/src/include/ipq_api.h"
	#include "opendpi-1.3.0/src/lib/ipq_main.h" 	// ipq library- UGLY UGLY UGLY!!

	#include "tranalyzer.h"
	#include "main.h"
	#include "hashTable.h"
	#include "networkHeaders.h"
	#include "outputBuffer.h"
	
	#include "basicLayer4CalcStatistics.h"
/*==============================*/
/*enums declaration + definition*/
/*==============================*/
	#define OPENDPI_OUTPUT_AS_STRING 1 		// toggle between string or numeric output
	#define OPENDPI_MAKE_STATS 1			// Make overall protocol-statistics
	#define OPENDPI_MAKE_NN_OUTPUT 0		// make output suitable for neuro net-training
	#define OPENDPI_NN_MATCH 1			// value to set if class matches (only if MAKE_NN_OUTPUT == 1)
	#define	OPENDPI_NN_NOMATCH 0			// value to set if class doesent match (only if MAKE_NN_OUTPUT == 1)

	typedef struct openDPI_hash_lookup_helper_s {
#if IPV6_ACTIVATE == 1
		ipAddr_t lower_ip, upper_ip;
#else // IPV6_ACTIVATE == 0
		in_addr_t lower_ip, upper_ip;
#endif // IPV6_ACTIVATE
		unsigned short vlan_id;
		unsigned short lower_port;
		unsigned short upper_port;
		uint8_t layer_4_protocol;
	} openDPI_hash_lookup_helper_t;

	typedef struct{
		struct ipoque_flow_struct *ipoque_flow;
		struct ipoque_id_struct *lower_ip_states;
		struct ipoque_id_struct *upper_ip_states;
		uint32_t protocol;			// the analyzed protocol
#if OPENDPI_MAKE_STATS > 0
		unsigned int flow_size; 		// size of flow (sum snapIpLength of packet [ means no size of ethernet header..!])
#endif
	} openDPI_flow;

/*==============================*/
/*     global declarations      */
/*==============================*/

	unsigned long *openDPI_flowIndex; // table for the openDPI flow index numbers
	openDPI_flow *openDPI_flows; // table for the flows

/*==============================*/
/*    function declarations     */
/*==============================*/
	/* Tranalyzer Pluginfunctions 
	*	- See tranalyzer doc for more information
	*/

	char* get_plugin_name();
	char* get_plugin_version();
	char* get_dependencies();
	unsigned int get_supported_tranalyzer_version_major();
	unsigned int get_supported_tranalyzer_version_minor();

	void initialize(unsigned long pPluginIndex);
	binary_value_t* printHeader();
	void onFlowGenerated(packet_t *packet, unsigned long flowIndex);
	void claimLayer4Information(packet_t *packet, unsigned long flowIndex);
	void onFlowTerminate(unsigned long flowIndex);
	void onApplicationTerminate();

#endif
