/*
 * ospfDecode.h
 * Copyright (C), RUAG AG, RUAG Defence AG, Switzerland
 * Author: Stefan Burschka, RDNIZ
 */

#ifndef OSPFDECODE_H_
#define OSPFDECODE_H_

// global includes
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>

// local includes
#include "main.h"
#include "outputBuffer.h"
#include "binaryValue.h"
#include "networkHeaders.h"

// user defines

// plugin defines

// sample plugin structures
typedef struct ospfFlow_s { // always large variables first to limit memory fragmentation
	uint8_t stat;
} ospfFlow_t;

// functions
char* get_plugin_name();
char* get_plugin_version();
unsigned int get_supported_tranalyzer_version_major();
unsigned int get_supported_tranalyzer_version_minor();
void initialize(unsigned long pPluginIndex);
binary_value_t* printHeader();
void onFlowGenerated(packet_t* packet, unsigned long flowIndex);
void claimLayer4Information(packet_t* packet, unsigned long flowIndex);
void onFlowTerminate(unsigned long flowIndex);
void onApplicationTerminate();

#endif // OSPFDECODE

