/*
 * pcapd.h
 * Copyright (C), RUAG AG, RUAG Defence AG, Switzerland
 * Author: Stefan Burschka, RDNIZ
 */

#ifndef PCAPD_H_
#define PCAPD_H_

// local includes
#include "main.h"
#include "networkHeaders.h"

// user defines
#define PCAPFILEN ".pcap"
#define ESOMFILEN "_esom_flows.lrn"

// local defines
#define ERROR_PREFIX "pcapd"
#define MAXPCAPR 4096

// functions
char* get_plugin_name();
char* get_plugin_version();
unsigned int get_supported_tranalyzer_version_major();
unsigned int get_supported_tranalyzer_version_minor();

void initialize(unsigned long pPluginIndex);
void onFlowGenerated(packet_t* packet, unsigned long flowIndex);
void claimLayer4Information(packet_t* packet, unsigned long flowIndex);
void onFlowTerminate(unsigned long flowIndex);
void onApplicationTerminate();

// variables
unsigned long plugin_pcap_Index;

#endif // PCAPD_H_

