/*
 * tranalyzer_plugin_skeleton.h
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef PORT_BASED_H_
#define PORT_BASED_H_

#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>

#include "string.h"

#include "networkHeaders.h"
#include "main.h"
#include "tranalyzer.h"
#include "binaryValue.h"
#include "getter.h"

#define PBC_STRING 1
#define PORT_BASED_CLASSIFICATION_FILE "portmap.txt" //Input File for the mapping between Ports and Application
#define MAX_LINE_LEN 1024
#define ERROR_PREFIX "portBasedClassifier:"


typedef struct s_portToAppl {
	char udp_appl_name[64];
	char tcp_appl_name[64];
} t_portToAppl;


//variables
t_portToAppl portClassificationArray[65536]; // association port-application
unsigned char go = 1; // Port based classifier active

unsigned long pluginPortBasedClassifierIndex;
#ifdef __APPLE__
// global variables
char *pluginFolder;
outputBuffer_t *main_output_buffer;
flow_t *flows;
#endif // __APPLE__ 

char* get_plugin_name();
char* get_plugin_version();
unsigned int get_supported_tranalyzer_version_major();
unsigned int get_supported_tranalyzer_version_minor();
void initialize(unsigned long pPluginIndex);
binary_value_t* printHeader();
void onFlowTerminate(unsigned long flowIndex);


#endif /* PORT_BASED_H_ */
