/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef __PROTOCOLSTATISTICS_H__
#define __PROTOCOLSTATISTICS_H__

#define PROTOCOLS_SUFFIX "_protocols.txt"
#define PROTOFILE "proto.txt"
#define PORTFILE "portmap.txt"

// includes
#include "binaryValue.h"

// local includes
#include "tranalyzer.h"
#include "main.h"
#include "getter.h"
#include "networkHeaders.h"

// Local defines
#define MAXFILENAMELEN	256
#define IPPROTMAX	256
#define IPPROTMAXLEN	100

#define L4PORTMAX	65536
#define L4PORTMAXLEN	100

// variables
unsigned long numPackets[IPPROTMAX];
unsigned long tcpPortUsage[MAX_PORTS];
unsigned long udpPortUsage[MAX_PORTS];
unsigned long scpPortUsage[MAX_PORTS];

char l4_portname[2][L4PORTMAX][L4PORTMAXLEN];

char protocolStatsFileName[MAX_FILENAME_LEN+1]; // filename of the protocols file
FILE *protocolStatsFile;

unsigned long pluginProtocolStatistics;

// functions
char* get_plugin_name();
char* get_plugin_version();
unsigned int get_supported_tranalyzer_version_major();
unsigned int get_supported_tranalyzer_version_minor();
void onApplicationTerminate(unsigned long flowIndex);
void initialize(unsigned long pPluginIndex);
void claimLayer3Information(packet_t *packet);
void claimLayer4Information(packet_t *packet, unsigned long flowIndex);
#ifdef __APPLE__
char *baseFileName;
flow_t *flows;
unsigned long numOfV4Packets;
unsigned long numOfV6Packets;
#endif
#endif

