/*
 * standardFileSink.h
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef STANDARD_FILE_SINK_H_
#define STANDARD_FILE_SINK_H_

#define FLOWS_SUFFIX "_flows.bin"

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>

#include "main.h"
#include "tranalyzer.h"
#include "getter.h"

// user defines
#define STD_BUFSHFT BUF_DATA_SHFT * 4

// local plugin defines


// plugin defines
FILE* outputFile;
char outputFileName[MAX_FILENAME_LEN+1]; // filename of the flows file
unsigned long pluginStandardFileSinkIndex;
#ifdef __APPLE__
binary_value_t *main_header_bv;
char *baseFileName;
#endif // __APPLE
char* get_plugin_name();
char* get_plugin_version();
unsigned int get_supported_tranalyzer_version_major();
unsigned int get_supported_tranalyzer_version_minor();

void initialize(unsigned long pPluginIndex);
void onApplicationTerminate();
void bufferToSink(outputBuffer_t *buffer);

static uint32_t Checksum(uint32_t *data, uint32_t byteLen);

#endif /* STANDARD_FILE_SINK_H_ */
