/*
 * textFileSink.h
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef TEXTFILESINK_H_
#define TEXTFILESINK_H_

#include "main.h"
#include "outputBuffer.h"
#include "binaryValue.h"
#include "networkHeaders.h"
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>

// User defines
#define FLOWS_TEXT_SUFFIX "_flows.txt"
#define HEADER_SUFFIX "_headers.txt"
#define TEXT_FILE_SINK_PRINT_HEADER 1		// if != 0 the plugin prints a header row at the start of the output file
#define TEXT_FILE_SINK_PRINT_HEADER_FILE 1	// if != 0 the plugin prints a header file with detailed information about all columns

// local defines

// local variables
FILE *txt_output_file, *header_output_file;
char txt_output_file_name[MAX_FILENAME_LEN+1]="stdout\0"; // filename of the flows file
char header_output_file_name[MAX_FILENAME_LEN+1]; // filename of the header file

// global variables
extern char *baseFileName;
extern outputBuffer_t* main_output_buffer;
extern binary_value_t* main_header_bv;

//functions
char* get_plugin_name();
char* get_plugin_version();
unsigned int get_supported_tranalyzer_version_major();
unsigned int get_supported_tranalyzer_version_minor();
void initialize(unsigned long pPluginIndex);
void onApplicationTerminate();
void bufferToSink(outputBuffer_t *buffer);
unsigned long pluginTextFileSinkIndex;

#endif /* TEXTFILESINK_H_ */
