/*
 * outputBuffer.c
 *
 *  Created on: Mar 22, 2010
 *      Author: torben
 */

#include "outputBuffer.h"
#include <string.h>

outputBuffer_t *outputBuffer_initialize(size_t size_of_buffer) {
	outputBuffer_t* buffer = malloc(sizeof(outputBuffer_t));
	buffer->size_of_buffer = size_of_buffer;
	buffer->buffer = malloc(buffer->size_of_buffer + 1 * sizeof(char));
	memset(buffer->buffer, '\0', buffer->size_of_buffer + 1 * sizeof(char));
	buffer->size_of_buffer -= BUFFER_DATAP;
	buffer->buffer += BUFFER_DATAP;
	buffer->act_pos = 0;
	return buffer;
}

int outputBuffer_append(outputBuffer_t* buffer, char* output, size_t size_of_output) {
	if (buffer->act_pos + size_of_output >= buffer->size_of_buffer) {
		fprintf(stderr, "outputBuffer.c: buffer overflow!\n");
		exit(-1);
//		return 1; // appending was NOT successfull
	}
	memcpy(&(buffer->buffer[buffer->act_pos]), output, size_of_output);
	buffer->act_pos += (uint32_t) size_of_output;
	buffer->buffer[buffer->act_pos] = '\0'; // terminate string
	return 0; // appending was successfull
}

int outputBuffer_reset(outputBuffer_t* buffer) {
	buffer->buffer[BUFFER_DATAP] = '\0';
	buffer->act_pos = 0;
	return 0;
}

int outputBuffer_destroy(outputBuffer_t* buffer) {
	if (buffer) {
		buffer->buffer -= BUFFER_DATAP;
		free(buffer->buffer);
		free(buffer);
		return 0; // destroying was successfull
	} else {
		return 1; // buffer doesn't exist
	}
}
