#ifndef __VECTOR_H__
#define __VECTOR_H__

// includes
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

// structs
typedef struct vector_s {
	unsigned long sizePerItem;
	unsigned long numAllocatedItems;
	unsigned long numCurrentUsedItems;
	float incrementationStep;
	void *data;
} vector_t;


// functions
vector_t* initVector(unsigned long itemSize, unsigned long initSize, float incrementationStep);
void pushVector(vector_t *vector, void *newData);
void* linearLookupVector(vector_t *vector, void *data, unsigned long compareSize);
void* getVectorElement(vector_t *vector, unsigned long index);
void destroyVector(vector_t *vector);

#endif

