/*
 * malsite.h
 * Copyright (C), RUAG AG, RUAG Defence AG, Switzerland
 * Author: Noe Thalheim, RDNIZ
 * Co-Author: Stefan Burschka, RDNIZ
 *
*/


#ifndef MALSITE_H_
#define MALSITE_H_

// global plugin defines
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <inttypes.h>
#include "networkHeaders.h"

// user defines
#define	TF_MALSITE_DOMAIN 1

// plugin defines 
#define MAXLENDMN	256

// global plugin structs
typedef struct malsite {
	uint32_t malId;
#if TF_MALSITE_DOMAIN == 0
	ipAddr_t malIp; // in Host Order ! 
#else // TF_MALSITE_DOMAIN == 1
	uint8_t len;
	char malDomain[MAXLENDMN];
#endif  //TF_MALSITE_DOMAIN
} malsite_t;

typedef struct malsitetable {
	uint32_t count;
	malsite_t* malsites;
} malsitetable_t;


// global plugin function defs
void malsite_init(malsitetable_t* table, char* bw_file);
int malsite_load(char* bw_file, malsite_t* malsites);

#if TF_MALSITE_DOMAIN == 1
inline uint32_t maldomain_test(malsitetable_t* table, char* domain, uint8_t len);
#else // TF_MALSITE_DOMAIN == 0
inline uint32_t malip_test(malsitetable_t* table, ipAddr_t ip);
#endif  //TF_MALSITE_DOMAIN


#endif /* MALSITE_H_ */
